searchData={"items":[{"type":"module","doc":"AI is a behavior module that defines the interface for interacting with\nOpenAI's API. It provides a common interface for the various OpenAI-powered\noperations used by the application.","title":"AI","ref":"AI.html"},{"type":"function","doc":"","title":"AI.get_completion/4","ref":"AI.html#get_completion/4"},{"type":"function","doc":"Get embeddings for the given text. The text is split into chunks of 8192\ntokens to avoid exceeding the model's input limit. Returns a list of\nembeddings for each chunk.","title":"AI.get_embeddings/2","ref":"AI.html#get_embeddings/2"},{"type":"function","doc":"Create a new AI instance. Instances share the same client connection.","title":"AI.new/0","ref":"AI.html#new/0"},{"type":"type","doc":"","title":"AI.t/0","ref":"AI.html#t:t/0"},{"type":"module","doc":"When file or other input to too large for the model's context window, this\nmodule may be used to process the file in chunks. It automatically modifies\nthe supplied agent prompt to include instructions for accumulating a response\nacross multiple chunks based on the `max_tokens` parameter supplied to the\n`get_response` function.","title":"AI.Accumulator","ref":"AI.Accumulator.html"},{"type":"function","doc":"","title":"AI.Accumulator.get_response/2","ref":"AI.Accumulator.html#get_response/2"},{"type":"module","doc":"","title":"AI.Agent.Answers","ref":"AI.Agent.Answers.html"},{"type":"function","doc":"","title":"AI.Agent.Answers.perform/2","ref":"AI.Agent.Answers.html#perform/2"},{"type":"module","doc":"","title":"AI.Agent.CodeMapper","ref":"AI.Agent.CodeMapper.html"},{"type":"function","doc":"","title":"AI.Agent.CodeMapper.get_response/3","ref":"AI.Agent.CodeMapper.html#get_response/3"},{"type":"module","doc":"","title":"AI.Agent.FileInfo","ref":"AI.Agent.FileInfo.html"},{"type":"function","doc":"","title":"AI.Agent.FileInfo.get_response/4","ref":"AI.Agent.FileInfo.html#get_response/4"},{"type":"module","doc":"This module provides an agent that summarizes files' contents in order to\ngenerate embeddings for the database and summaries for the user.","title":"AI.Agent.FileSummary","ref":"AI.Agent.FileSummary.html"},{"type":"function","doc":"","title":"AI.Agent.FileSummary.get_response/3","ref":"AI.Agent.FileSummary.html#get_response/3"},{"type":"module","doc":"","title":"AI.Agent.Spelunker","ref":"AI.Agent.Spelunker.html"},{"type":"function","doc":"","title":"AI.Agent.Spelunker.perform/2","ref":"AI.Agent.Spelunker.html#perform/2"},{"type":"module","doc":"This module provides functions to interact with the OpenAI API, including\ngetting embeddings and completions.","title":"AI.OpenAI","ref":"AI.OpenAI.html"},{"type":"function","doc":"","title":"AI.OpenAI.get_completion/4","ref":"AI.OpenAI.html#get_completion/4"},{"type":"function","doc":"","title":"AI.OpenAI.get_embedding/3","ref":"AI.OpenAI.html#get_embedding/3"},{"type":"function","doc":"","title":"AI.OpenAI.new/1","ref":"AI.OpenAI.html#new/1"},{"type":"module","doc":"This module sends a request to the model and handles the response. It is able\nto handle tool calls and responses. If the caller includes an `on_event`\nfunction, it will be called whenever a tool call is performed or if a tool\ncall results in an error.","title":"AI.Response","ref":"AI.Response.html"},{"type":"function","doc":"","title":"AI.Response.get/2","ref":"AI.Response.html#get/2"},{"type":"function","doc":"","title":"AI.Response.handle_tool_call/2","ref":"AI.Response.html#handle_tool_call/2"},{"type":"module","doc":"This module is used to split a string into chunks by the number of tokens,\nwhile accounting for *other* data that might be going with it to the API\nendpoint with the limited token count.\n\nFor example, the search entry agent may be processing a large file, one that\nmust be split into 3 slices just to fit it into the payload of an API call.\nIn order to retain context between chunks, the agent essentially _reduces_\nover the file, keeping track of information in the previous chunks to\ngenerate a final summary. Doing that means that we need to not only split the\nfile by the number of tokens in each slice, but also keep some space for the\nbespoke data that will be added to the payload as the agent's \"accumulator\".","title":"AI.Splitter","ref":"AI.Splitter.html"},{"type":"function","doc":"","title":"AI.Splitter.new/2","ref":"AI.Splitter.html#new/2"},{"type":"function","doc":"","title":"AI.Splitter.next_chunk/2","ref":"AI.Splitter.html#next_chunk/2"},{"type":"behaviour","doc":"> Oh yeah? I'm gonna make my own tokenizer, with blackjack and hookers!\n                                                    -- ~Bender~ ChatGPT\n\nThe only tokenizer modules available when this was written are either older\nand don't correctly count for OpenAI's newer models (Gpt3Tokenizer) or can't\nbe used in an escript because they require priv access or OTP support beyond\nescript's abilities (Tokenizers).\n\nThis module tokenizes text using the `o200k_base` vocabulary and merges files\nfrom OpenAI's tiktoken repo.","title":"AI.Tokenizer","ref":"AI.Tokenizer.html"},{"type":"function","doc":"","title":"AI.Tokenizer.chunk/2","ref":"AI.Tokenizer.html#chunk/2"},{"type":"callback","doc":"","title":"AI.Tokenizer.decode/1","ref":"AI.Tokenizer.html#c:decode/1"},{"type":"callback","doc":"","title":"AI.Tokenizer.encode/1","ref":"AI.Tokenizer.html#c:encode/1"},{"type":"function","doc":"","title":"AI.Tokenizer.get_impl/0","ref":"AI.Tokenizer.html#get_impl/0"},{"type":"module","doc":"","title":"AI.Tokens_o200k_base","ref":"AI.Tokens_o200k_base.html"},{"type":"function","doc":"","title":"AI.Tokens_o200k_base.get_merges/0","ref":"AI.Tokens_o200k_base.html#get_merges/0"},{"type":"function","doc":"","title":"AI.Tokens_o200k_base.get_pattern/0","ref":"AI.Tokens_o200k_base.html#get_pattern/0"},{"type":"function","doc":"","title":"AI.Tokens_o200k_base.get_reverse_vocab/0","ref":"AI.Tokens_o200k_base.html#get_reverse_vocab/0"},{"type":"function","doc":"","title":"AI.Tokens_o200k_base.get_special_tokens/0","ref":"AI.Tokens_o200k_base.html#get_special_tokens/0"},{"type":"function","doc":"","title":"AI.Tokens_o200k_base.get_vocab/0","ref":"AI.Tokens_o200k_base.html#get_vocab/0"},{"type":"behaviour","doc":"","title":"AI.Tools","ref":"AI.Tools.html"},{"type":"callback","doc":"","title":"AI.Tools.call/2","ref":"AI.Tools.html#c:call/2"},{"type":"callback","doc":"","title":"AI.Tools.spec/0","ref":"AI.Tools.html#c:spec/0"},{"type":"module","doc":"","title":"AI.Tools.FileInfo","ref":"AI.Tools.FileInfo.html"},{"type":"module","doc":"","title":"AI.Tools.GitPickaxe","ref":"AI.Tools.GitPickaxe.html"},{"type":"module","doc":"","title":"AI.Tools.GitShow","ref":"AI.Tools.GitShow.html"},{"type":"module","doc":"","title":"AI.Tools.ListFiles","ref":"AI.Tools.ListFiles.html"},{"type":"module","doc":"","title":"AI.Tools.Outline","ref":"AI.Tools.Outline.html"},{"type":"module","doc":"","title":"AI.Tools.Search","ref":"AI.Tools.Search.html"},{"type":"module","doc":"","title":"AI.Tools.Spelunker","ref":"AI.Tools.Spelunker.html"},{"type":"module","doc":"","title":"AI.Util","ref":"AI.Util.html"},{"type":"function","doc":"Creates an assistant message object, representing the assistant's response.","title":"AI.Util.assistant_msg/1","ref":"AI.Util.html#assistant_msg/1"},{"type":"function","doc":"This is the tool call message, which must come immediately before the\n`tool_msg/3` message with the same `tool_call_id` (`id`).","title":"AI.Util.assistant_tool_msg/3","ref":"AI.Util.html#assistant_tool_msg/3"},{"type":"function","doc":"Creates a system message object, used to define the assistant's behavior for\nthe conversation.","title":"AI.Util.system_msg/1","ref":"AI.Util.html#system_msg/1"},{"type":"function","doc":"This is the tool outputs message, which must come immediately after the\n`assistant_tool_msg/3` message with the same `tool_call_id` (`id`).","title":"AI.Util.tool_msg/3","ref":"AI.Util.html#tool_msg/3"},{"type":"function","doc":"Creates a user message object, representing the user's input prompt.","title":"AI.Util.user_msg/1","ref":"AI.Util.html#user_msg/1"},{"type":"module","doc":"","title":"Cmd.Ask","ref":"Cmd.Ask.html"},{"type":"function","doc":"","title":"Cmd.Ask.run/1","ref":"Cmd.Ask.html#run/1"},{"type":"module","doc":"","title":"Cmd.Files","ref":"Cmd.Files.html"},{"type":"function","doc":"","title":"Cmd.Files.run/1","ref":"Cmd.Files.html#run/1"},{"type":"module","doc":"This module provides the functionality for the `index` sub-command.","title":"Cmd.Indexer","ref":"Cmd.Indexer.html"},{"type":"function","doc":"Create a new `Indexer` struct.","title":"Cmd.Indexer.new/2","ref":"Cmd.Indexer.html#new/2"},{"type":"function","doc":"Run the indexing process using the given `Indexer` struct. If `force_reindex`\nis `true`, the project will be deleted and reindexed from scratch.","title":"Cmd.Indexer.run/1","ref":"Cmd.Indexer.html#run/1"},{"type":"module","doc":"","title":"Cmd.Projects","ref":"Cmd.Projects.html"},{"type":"function","doc":"","title":"Cmd.Projects.run/1","ref":"Cmd.Projects.html#run/1"},{"type":"module","doc":"This module provides the functionality for the `search` sub-command.","title":"Cmd.Search","ref":"Cmd.Search.html"},{"type":"function","doc":"Searches the given project for previously indexed files (see `Indexing`) that\nmatch the given query. The search results are printed to the console.\n\nNote that the query input is first sent to OpenAI's API to generate an\nembedding to match against the vector store.","title":"Cmd.Search.run/2","ref":"Cmd.Search.html#run/2"},{"type":"module","doc":"This module provides the functionality for the `summary` sub-command.","title":"Cmd.Summary","ref":"Cmd.Summary.html"},{"type":"function","doc":"Run the summary process using the given `project` and `file_path`.","title":"Cmd.Summary.run/1","ref":"Cmd.Summary.html#run/1"},{"type":"module","doc":"","title":"Cmd.Torch","ref":"Cmd.Torch.html"},{"type":"function","doc":"Permanently deletes the project from the store.","title":"Cmd.Torch.run/1","ref":"Cmd.Torch.html#run/1"},{"type":"module","doc":"","title":"Cmd.Upgrade","ref":"Cmd.Upgrade.html"},{"type":"function","doc":"","title":"Cmd.Upgrade.run/1","ref":"Cmd.Upgrade.html#run/1"},{"type":"module","doc":"Fnord is a code search tool that uses OpenAI's embeddings API to index and\nsearch code files.","title":"Fnord","ref":"Fnord.html"},{"type":"function","doc":"","title":"Fnord.configure_logger/0","ref":"Fnord.html#configure_logger/0"},{"type":"function","doc":"Main entry point for the application. Parses command line arguments and\ndispatches to the appropriate subcommand.","title":"Fnord.main/1","ref":"Fnord.html#main/1"},{"type":"module","doc":"Module for interacting with git.","title":"Git","ref":"Git.html"},{"type":"function","doc":"","title":"Git.is_git_repo?/0","ref":"Git.html#is_git_repo?/0"},{"type":"function","doc":"","title":"Git.is_git_repo?/1","ref":"Git.html#is_git_repo?/1"},{"type":"function","doc":"","title":"Git.is_ignored?/2","ref":"Git.html#is_ignored?/2"},{"type":"function","doc":"","title":"Git.pickaxe_regex/2","ref":"Git.html#pickaxe_regex/2"},{"type":"function","doc":"","title":"Git.show/2","ref":"Git.html#show/2"},{"type":"function","doc":"","title":"Git.show/3","ref":"Git.html#show/3"},{"type":"module","doc":"","title":"Http","ref":"Http.html"},{"type":"function","doc":"","title":"Http.post_json/4","ref":"Http.html#post_json/4"},{"type":"behaviour","doc":"This behaviour wraps the AI-powered operations used by `Cmd.Indexer` to allow\noverrides for testing.","title":"Indexer","ref":"Indexer.html"},{"type":"callback","doc":"","title":"Indexer.get_embeddings/2","ref":"Indexer.html#c:get_embeddings/2"},{"type":"callback","doc":"","title":"Indexer.get_outline/3","ref":"Indexer.html#c:get_outline/3"},{"type":"callback","doc":"","title":"Indexer.get_summary/3","ref":"Indexer.html#c:get_summary/3"},{"type":"callback","doc":"","title":"Indexer.new/0","ref":"Indexer.html#c:new/0"},{"type":"type","doc":"","title":"Indexer.completion/0","ref":"Indexer.html#t:completion/0"},{"type":"type","doc":"","title":"Indexer.embeddings/0","ref":"Indexer.html#t:embeddings/0"},{"type":"type","doc":"","title":"Indexer.error/0","ref":"Indexer.html#t:error/0"},{"type":"type","doc":"","title":"Indexer.file_content/0","ref":"Indexer.html#t:file_content/0"},{"type":"type","doc":"","title":"Indexer.file_path/0","ref":"Indexer.html#t:file_path/0"},{"type":"type","doc":"","title":"Indexer.indexer/0","ref":"Indexer.html#t:indexer/0"},{"type":"module","doc":"A module that implements a process pool using a GenServer.","title":"Queue","ref":"Queue.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"Queue.child_spec/1","ref":"Queue.html#child_spec/1"},{"type":"function","doc":"","title":"Queue.init/1","ref":"Queue.html#init/1"},{"type":"function","doc":"Waits until the queue is empty and all workers have exited.","title":"Queue.join/1","ref":"Queue.html#join/1"},{"type":"function","doc":"Queues an Enum of jobs, executes them, and returns the results in order.","title":"Queue.map/2","ref":"Queue.html#map/2"},{"type":"function","doc":"Adds a job to the queue and returns a Task.","title":"Queue.queue/2","ref":"Queue.html#queue/2"},{"type":"function","doc":"Shuts down the queue, preventing new jobs from being added.","title":"Queue.shutdown/1","ref":"Queue.html#shutdown/1"},{"type":"function","doc":"Starts the Queue with the given callback function and maximum number of workers.\nReturns {:ok, pid}","title":"Queue.start_link/1","ref":"Queue.html#start_link/1"},{"type":"module","doc":"The `Scanner` module traverses a directory recursively, skipping hidden files\nand files that should be ignored based on a `.gitignore` file. It also skips\nbinary files and files with a size of 0 bytes.","title":"Scanner","ref":"Scanner.html"},{"type":"function","doc":"Count the number of files in the directory, excluding hidden, ignored,\nbinary, and empty files.","title":"Scanner.count_files/1","ref":"Scanner.html#count_files/1"},{"type":"function","doc":"Create a new `Scanner` struct.","title":"Scanner.new/2","ref":"Scanner.html#new/2"},{"type":"function","doc":"Recursively scan the directory and accumulate a result using the provided\naccumulator and function.","title":"Scanner.reduce/4","ref":"Scanner.html#reduce/4"},{"type":"function","doc":"Recursively scan the directory and call the callback function for each file.","title":"Scanner.scan/2","ref":"Scanner.html#scan/2"},{"type":"module","doc":"","title":"Search","ref":"Search.html"},{"type":"function","doc":"","title":"Search.cosine_similarity/2","ref":"Search.html#cosine_similarity/2"},{"type":"function","doc":"","title":"Search.get_results/1","ref":"Search.html#get_results/1"},{"type":"function","doc":"Creates a new `Search` struct with the given options.","title":"Search.new/2","ref":"Search.html#new/2"},{"type":"module","doc":"","title":"Settings","ref":"Settings.html"},{"type":"function","doc":"Get a value from the settings store.","title":"Settings.get/3","ref":"Settings.html#get/3"},{"type":"function","doc":"","title":"Settings.get_project/1","ref":"Settings.html#get_project/1"},{"type":"function","doc":"","title":"Settings.get_root/1","ref":"Settings.html#get_root/1"},{"type":"function","doc":"Get the project specified with --project. If the project name is not set, an\nerror will be raised.","title":"Settings.get_selected_project!/0","ref":"Settings.html#get_selected_project!/0"},{"type":"function","doc":"Get the path to the store root directory.","title":"Settings.home/0","ref":"Settings.html#home/0"},{"type":"function","doc":"","title":"Settings.new/0","ref":"Settings.html#new/0"},{"type":"function","doc":"Set a value in the settings store.","title":"Settings.set/3","ref":"Settings.html#set/3"},{"type":"function","doc":"","title":"Settings.set_project/2","ref":"Settings.html#set_project/2"},{"type":"function","doc":"Get the path to the settings file.","title":"Settings.settings_file/0","ref":"Settings.html#settings_file/0"},{"type":"module","doc":"","title":"Spinner","ref":"Spinner.html"},{"type":"function","doc":"","title":"Spinner.run/2","ref":"Spinner.html#run/2"},{"type":"module","doc":"This module provides the functionality for storing and retrieving embeddings\nand metadata for files.","title":"Store","ref":"Store.html"},{"type":"function","doc":"Creates the project directory if it does not already exist. This will create\na new directory in the store with the name of the project.","title":"Store.create_project/0","ref":"Store.html#create_project/0"},{"type":"function","doc":"Permanently deletes the specified file from the store. Note that this is\n_only_ exposed for the sake of testing.","title":"Store.delete_file/2","ref":"Store.html#delete_file/2"},{"type":"function","doc":"Permanently delete any files that are indexed but no longer exist on disk.","title":"Store.delete_missing_files/2","ref":"Store.html#delete_missing_files/2"},{"type":"function","doc":"Permanently deletes the specified project's index directory and all its\ncontents.","title":"Store.delete_project/1","ref":"Store.html#delete_project/1"},{"type":"function","doc":"Get the metadata, summary, and embeddings for the specified file. Returns\n`{:ok, info}` if the file exists, or `{:error, :not_found}` if it does not.\n\nThe structure of the returned `info` is as follows:\n\n```\n%{\n  file: \"path/to/file.ext\",\n  hash: \"DEADBEEF\",\n  timestamp: \"2021-01-01T00:00:00Z\",\n  summary: \"AI-generated summary of the file\",\n  embeddings: [\n    [0.1, 0.2, 0.3, ...],\n    [0.4, 0.5, 0.6, ...],\n    ...\n  ]\n}\n```","title":"Store.get/2","ref":"Store.html#get/2"},{"type":"function","doc":"Get the embeddings for the specified file. Returns `{:ok, embeddings}` if the\nfile exists, or `{:error, :not_found}` if it does not. Note that if the input\nfile was greater than 8192 tokens, the embeddings will be split into multiple\nchunks.","title":"Store.get_embeddings/2","ref":"Store.html#get_embeddings/2"},{"type":"function","doc":"Get the path to the directory containing the metadata for the specified file.","title":"Store.get_entry_path/2","ref":"Store.html#get_entry_path/2"},{"type":"function","doc":"Get the hash for the specified file. Returns `{:ok, hash}` if the file\nexists, or `{:error, :not_found}` if it does not.","title":"Store.get_hash/2","ref":"Store.html#get_hash/2"},{"type":"function","doc":"Get the key for the specified file, which is based on the file's full path\nand is used as the directory name for the file's metadata.","title":"Store.get_key/1","ref":"Store.html#get_key/1"},{"type":"function","doc":"Get the symbol/ctags style outline for the specified file. Returns `{:ok,\noutline}` if the file exists, or `{:error, :not_found}` if it does not.","title":"Store.get_outline/2","ref":"Store.html#get_outline/2"},{"type":"function","doc":"Get the project directory. This is the directory where the project's files\nare stored.","title":"Store.get_project_dir/0","ref":"Store.html#get_project_dir/0"},{"type":"function","doc":"Get the summary for the specified file. Returns `{:ok, summary}` if the file\nexists, or `{:error, :not_found}` if it does not.","title":"Store.get_summary/2","ref":"Store.html#get_summary/2"},{"type":"function","doc":"Check if the specified file has embeddings. Returns `true` if any exist,\n`false` otherwise.","title":"Store.has_embeddings?/2","ref":"Store.html#has_embeddings?/2"},{"type":"function","doc":"Check if the specified file has an outline outline. Returns `true` if the file\nexists, or `false` if it does not.","title":"Store.has_outline?/2","ref":"Store.html#has_outline?/2"},{"type":"function","doc":"Check if the specified file has a summary file. Returns `true` if the file exists,\nor `false` if it does not.","title":"Store.has_summary?/2","ref":"Store.html#has_summary?/2"},{"type":"function","doc":"Get the metadata for the specified file. Returns `{:ok, data}` if the file\nexists, or `{:error, :not_found}` if it does not. The structure of the\nmetadata is as follows:\n\n```\n%{\n  file: \"path/to/file.ext\",\n  hash: \"DEADBEEF\",\n  timestamp: \"2021-01-01T00:00:00Z\",\n  fnord_path: \"path/to/store/FEEBDAED\"\n}\n```","title":"Store.info/2","ref":"Store.html#info/2"},{"type":"function","doc":"List all indexed files in the project. Returns a list of absolute, expanded,\nfile paths.","title":"Store.list_files/1","ref":"Store.html#list_files/1"},{"type":"function","doc":"List all projects in the store. Returns a list of project names.","title":"Store.list_projects/0","ref":"Store.html#list_projects/0"},{"type":"function","doc":"Create a new `Store` struct.","title":"Store.new/0","ref":"Store.html#new/0"},{"type":"function","doc":"Returns true if the selected project exists in the store. A project exists\nin the store if:\n1. The project directory exists in the store.\n2. There are entries in the project directory.","title":"Store.project_exists?/0","ref":"Store.html#project_exists?/0"},{"type":"function","doc":"Store the metadata, summary, and embeddings for the specified file. If the\nfile already exists in the store, it will be overwritten.","title":"Store.put/6","ref":"Store.html#put/6"},{"type":"module","doc":"","title":"UI","ref":"UI.html"},{"type":"function","doc":"","title":"UI.debug/1","ref":"UI.html#debug/1"},{"type":"function","doc":"","title":"UI.debug/2","ref":"UI.html#debug/2"},{"type":"function","doc":"","title":"UI.error/1","ref":"UI.html#error/1"},{"type":"function","doc":"","title":"UI.error/2","ref":"UI.html#error/2"},{"type":"function","doc":"","title":"UI.flush/0","ref":"UI.html#flush/0"},{"type":"function","doc":"","title":"UI.info/1","ref":"UI.html#info/1"},{"type":"function","doc":"","title":"UI.info/2","ref":"UI.html#info/2"},{"type":"function","doc":"","title":"UI.report_step/1","ref":"UI.html#report_step/1"},{"type":"function","doc":"","title":"UI.report_step/2","ref":"UI.html#report_step/2"},{"type":"function","doc":"","title":"UI.warn/1","ref":"UI.html#warn/1"},{"type":"function","doc":"","title":"UI.warn/2","ref":"UI.html#warn/2"},{"type":"extras","doc":"# Fnord\n\n[![Tests | Dialyzer](https://github.com/sysread/fnord/actions/workflows/run-tests.yml/badge.svg)](https://github.com/sysread/fnord/actions/workflows/run-tests.yml)\n\nFnord is a command line tool that uses multiple AI-powered agents and tools to\nprovide a conversational interface to your codebase, notes, and other\n(non-binary) files.","title":"Fnord","ref":"readme.html"},{"type":"extras","doc":"- Code base search\n- Graph search and pathfinding\n- On-demand playbooks assembled from documentation and code\n- Troubleshooting and debugging\n- Git archaeology","title":"Features - Fnord","ref":"readme.html#features"},{"type":"extras","doc":"1. Install `elixir` if necessary:\n```bash\n# MacOS\nbrew install elixir\n\n# Debian-based\nsudo apt-get install elixir\n```\n\n2. Add the mix escript path to your shell's PATH:\n```bash\necho 'export PATH=\"$HOME/.mix/escripts:$PATH\"' >> ~/.bashrc\nsource ~/.bashrc\n```\n\n3. Install the script:\n```bash\nmix escript.install github sysread/fnord\n```\n\nUse the same command to reinstall. It will offer to overwrite the existing\ninstallation.\n\n4. Set `OPENAI_API_KEY`\n\nSet this in your shell environment to the OpenAI project key you wish to use\nfor this tool. You can create a new project and get a key\n[here](https://platform.openai.com/api-keys).","title":"Installation - Fnord","ref":"readme.html#installation"},{"type":"extras","doc":"","title":"Usage - Fnord","ref":"readme.html#usage"},{"type":"extras","doc":"The first step is to index your project. This will scan all files in the\nproject directory and create a searchable database.\n\nThe initial index, especially on a large codebase, can will take a while.\nSubsequent runs will be faster, re-indexing only those files which have changed\nsince they were last indexed.\n\nThe `--dir` option is required only for the initial indexing. Subsequent\nindexing will use the directory specified in the initial index.\n\n```bash\nfnord index --project foo --dir /path/to/foo\n```\n\nYou can **reindex** the project, forcing it to reindex all files.\n\n```bash\nfnord index --project foo --dir /path/to/foo --reindex\n```\n\nYou can also watch the project for changes and reindex them as they happen\nusing [watchman](https://github.com/facebook/watchman). Just be sure to use\n`--quiet` to suppress interactive output.\n\n```bash\nwatchman-make -p '**/*' --settle 5 --run \"fnord index --project $project --dir $project_root --quiet\"\n```\n\n...or use the `fnord-watch` script in the [tools directory on\nGitHub](https://github.com/sysread/fnord/blob/main/tools/fnord-watch).\n\n```bash\nfnord-watch -p foo -d /path/to/foo\n```","title":"Index - Fnord","ref":"readme.html#index"},{"type":"extras","doc":"Search for files in the project that match a query.\n\n```bash\nfnord search --project foo --query \"some search query\"\n```\n\nIf you want more detail about each file matched:\n\n```bash\nfnord search --project foo --query \"some search query\" --detail\n```","title":"Search - Fnord","ref":"readme.html#search"},{"type":"extras","doc":"Ask the AI assistant to answer questions about your project.\n\n```bash\nfnord ask foo \"how do you run the tests for this project?\"\n\n# Pipe output to `glow` to render markdown\nfnord ask foo \"summarize the dependencies of this project\" | glow\n```","title":"Ask - Fnord","ref":"readme.html#ask"},{"type":"extras","doc":"- **List projects:** `fnord projects`\n- **List files in a project:** `fnord files --project foo`\n- **Show the AI-generated summary of a file:** `fnord summary --project foo --file bar`\n- **Delete a project:** `fnord delete --project foo`\n\nNote that deleting a project only deletes from the index, not the actual files.","title":"Miscellaneous - Fnord","ref":"readme.html#miscellaneous"},{"type":"extras","doc":"Internally, the `ask` command uses the OpenAI chat completions API to generate\na response, implementing a function tool to allow the assistant to query the\ndatabase for information.\n\n`fnord` can be used to implement a similar tool for your own projects. While\nthe `ask` command severely limits the parameters that the assistant may utilize\n(`query` only, with `project` being provided by the user's invocation of the\ncommand), the following syntax includes the full set of parameters available\nfor the `search` command.\n\n```json\n{\n  \"name\": \"search_tool\",\n  \"description\": \"Searches for matching files and their contents in a project.\",\n  \"parameters\": {\n    \"type\": \"object\",\n    \"properties\": {\n      \"project\": {\n        \"type\": \"string\",\n        \"description\": \"Project name for the search.\"\n      },\n      \"query\": {\n        \"type\": \"string\",\n        \"description\": \"The search query string.\"\n      },\n      \"detail\": {\n        \"type\": \"boolean\",\n        \"description\": \"Include AI-generated file summary if set to true.\"\n      },\n      \"limit\": {\n        \"type\": \"integer\",\n        \"description\": \"Limit the number of results (default: 10).\"\n      },\n      \"concurrency\": {\n        \"type\": \"integer\",\n        \"description\": \"Number of concurrent threads to use for the search (default: 4).\"\n      }\n    },\n    \"required\": [\"project\", \"query\"]\n  }\n}\n```\n\n# TODO\n- user-configurable system prompt for a given project\n- ask: report how old the index is\n- tool to allow the assistant to save observations about the project\n  - automatically index these observations and either:\n    - make them searchable\n    - include them in the prompt","title":"Tool usage - Fnord","ref":"readme.html#tool-usage"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}